/**
 * BIN12.java
 *
 * File generated from the medication2::BIN12 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.ArrayList;
import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class BIN12.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "BIN", propOrder = {
	"mixed",
	"representation"
})
@XmlRootElement(name = "BIN")
public abstract class BIN12 extends net.ihe.gazelle.medication2.ANY2 {
	

	
	@XmlMixed
	public List<java.io.Serializable> mixed;
	/**
	 *                       Specifies the representation of the
	                            binary data that                      is the content of the binary data
	                            value.                   .
	 */
	@XmlAttribute(name = "representation")
	public net.ihe.gazelle.medication2.BinaryDataEncoding2 representation;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().remove(mixed_elt);
	}
	
	/**
	 * Return representation.
	 * @return representation :                       Specifies the representation of the
	                            binary data that                      is the content of the binary data
	                            value.                   
	 */
	public net.ihe.gazelle.medication2.BinaryDataEncoding2 getRepresentation() {
	    return representation;
	}
	
	/**
	 * Set a value to attribute representation.
	 * @param representation :                       Specifies the representation of the
	                            binary data that                      is the content of the binary data
	                            value.                   .
	 */
	public void setRepresentation(net.ihe.gazelle.medication2.BinaryDataEncoding2 representation) {
	    this.representation = representation;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "BIN").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(BIN12 bIN12, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (bIN12 != null){
   			net.ihe.gazelle.medication2.ANY2.validateByModule(bIN12, _location, cvm, diagnostic);
    	}
    }

}
